package de.fhw.swtvertiefung.knauf.kuchenzutatnm;

import javax.swing.JDialog;

import javax.swing.JFrame;
import javax.swing.JScrollPane;
import javax.swing.JList;
import javax.swing.JLabel;
import javax.swing.JButton;
import java.awt.GridBagLayout;
import java.awt.GridBagConstraints;
import java.util.Vector;

/**
 * @author Wolfgang Knauf
 * 
 * Dialog fr das Bearbeiten der Kuchen-Zutaten-Verknpfung.
 */
public class DialogKuchenZutatenBearbeiten extends JDialog
{

  private javax.swing.JPanel jContentPane = null;

  private JScrollPane jScrollPaneZutaten = null;

  private JList jListZutaten = null;

  private JLabel jLabelZutaten = null;

  private JButton jButtonOK = null;

  private JButton jButtonAbbrechen = null;
  
  /**
   * This is the default constructor
   * @param frameParent Parent-Fenster
   */
  public DialogKuchenZutatenBearbeiten(JFrame frameParent)
  {
    super(frameParent, true);
    initialize();
    
    //Ein paar Dummy-Daten:
    Vector vectorZutat = new Vector();
    vectorZutat.add ("Zutat 1");
    vectorZutat.add ("Zutat 2");
    vectorZutat.add ("Zutat 3");
    vectorZutat.add ("Zutat 4");
    vectorZutat.add ("Zutat 5");
    vectorZutat.add ("Zutat 6");
    vectorZutat.add ("Zutat 7");
    vectorZutat.add ("Zutat 8");
    vectorZutat.add ("Zutat 9");
    vectorZutat.add ("Zutat 10");
    vectorZutat.add ("Zutat 11");
    vectorZutat.add ("Zutat 11");
    vectorZutat.add ("Zutat 12");
    vectorZutat.add ("Zutat 13");
    this.jListZutaten.setListData(vectorZutat);
  }

  /**
   * This method initializes this
   * 
   * @return void
   */
  private void initialize()
  {
    this.setTitle("Kuchen-Zutaten bearbeiten");
    this.setSize(300, 200);
    this.setContentPane(getJContentPane());
  }

  /**
   * This method initializes jContentPane
   * 
   * @return javax.swing.JPanel
   */
  private javax.swing.JPanel getJContentPane()
  {
    if (jContentPane == null)
    {
      jLabelZutaten = new JLabel();
      GridBagConstraints gridBagConstraints20 = new GridBagConstraints();
      GridBagConstraints gridBagConstraints19 = new GridBagConstraints();
      GridBagConstraints gridBagConstraints18 = new GridBagConstraints();
      GridBagConstraints gridBagConstraints17 = new GridBagConstraints();
      jContentPane = new javax.swing.JPanel();
      jContentPane.setLayout(new GridBagLayout());
      jLabelZutaten.setText("Zutaten des Kuchens:");
      jLabelZutaten.setName("jLabelZutaten");
      gridBagConstraints17.gridx = 0;
      gridBagConstraints17.gridy = 1;
      gridBagConstraints17.weightx = 1.0;
      gridBagConstraints17.weighty = 1.0;
      gridBagConstraints17.fill = java.awt.GridBagConstraints.BOTH;
      gridBagConstraints17.ipadx = 0;
      gridBagConstraints17.ipady = 0;
      gridBagConstraints17.insets = new java.awt.Insets(5, 5, 5, 5);
      gridBagConstraints18.gridx = 0;
      gridBagConstraints18.gridy = 0;
      gridBagConstraints18.ipadx = 0;
      gridBagConstraints18.ipady = 0;
      gridBagConstraints18.insets = new java.awt.Insets(5, 5, 5, 5);
      gridBagConstraints18.anchor = java.awt.GridBagConstraints.WEST;
      gridBagConstraints19.gridx = 1;
      gridBagConstraints19.gridy = 0;
      gridBagConstraints19.ipadx = 0;
      gridBagConstraints19.ipady = 0;
      gridBagConstraints19.insets = new java.awt.Insets(5, 5, 5, 5);
      gridBagConstraints19.fill = java.awt.GridBagConstraints.HORIZONTAL;
      gridBagConstraints20.gridx = 1;
      gridBagConstraints20.gridy = 1;
      gridBagConstraints20.ipadx = 0;
      gridBagConstraints20.ipady = 0;
      gridBagConstraints20.insets = new java.awt.Insets(5, 5, 5, 5);
      gridBagConstraints20.fill = java.awt.GridBagConstraints.HORIZONTAL;
      gridBagConstraints20.anchor = java.awt.GridBagConstraints.NORTH;
      jContentPane.add(getJScrollPaneZutaten(), gridBagConstraints17);
      jContentPane.add(jLabelZutaten, gridBagConstraints18);
      jContentPane.add(getJButtonOK(), gridBagConstraints19);
      jContentPane.add(getJButtonAbbrechen(), gridBagConstraints20);
    }
    return jContentPane;
  }

  /**
   * This method initializes jScrollPane
   * 
   * @return javax.swing.JScrollPane
   */
  private JScrollPane getJScrollPaneZutaten()
  {
    if (jScrollPaneZutaten == null)
    {
      jScrollPaneZutaten = new JScrollPane();
      jScrollPaneZutaten.setName("jScrollPaneZutaten");
      jScrollPaneZutaten.setViewportView(getJListZutaten());
    }
    return jScrollPaneZutaten;
  }

  /**
   * This method initializes jList
   * 
   * @return javax.swing.JList
   */
  private JList getJListZutaten()
  {
    if (jListZutaten == null)
    {
      jListZutaten = new JList();
      jListZutaten.setName("jListZutaten");
    }
    return jListZutaten;
  }

  /**
   * This method initializes jButton
   * 
   * @return javax.swing.JButton
   */
  private JButton getJButtonOK()
  {
    if (jButtonOK == null)
    {
      jButtonOK = new JButton();
      jButtonOK.setName("jButtonOK");
      jButtonOK.setText("OK");
      jButtonOK.addActionListener(new java.awt.event.ActionListener()
      {
        public void actionPerformed(java.awt.event.ActionEvent e)
        {
          okKlick();
        }
      });
    }
    return jButtonOK;
  }

  /**
   * This method initializes jButton
   * 
   * @return javax.swing.JButton
   */
  private JButton getJButtonAbbrechen()
  {
    if (jButtonAbbrechen == null)
    {
      jButtonAbbrechen = new JButton();
      jButtonAbbrechen.setText("Abbrechen");
      jButtonAbbrechen.setName("jButtonAbbrechen");
      jButtonAbbrechen.addActionListener(new java.awt.event.ActionListener()
      {
        public void actionPerformed(java.awt.event.ActionEvent e)
        {
          abbrechenKlick();
        }
      });
    }
    return jButtonAbbrechen;
  }
  
  /**
   * Klick auf OK: Dialog schlieen.
   * 
   *  
   */
  private void okKlick()
  {
    /**@todo Logik zum Auslesen der Werte */

    this.dispose();
  }

  /**
   * Klick auf Abbrechen: Dialog schlieen und sonst nichts.
   * 
   *  
   */
  private void abbrechenKlick()
  {
    //Hier ist nichts weiter zu tun.
    this.dispose();
  }
}
