package de.fhw.swtvertiefung.knauf.kuchenzutatnm;

import javax.swing.JFrame;

import javax.swing.JOptionPane;
import javax.swing.JScrollPane;
import javax.swing.JList;
import javax.swing.JButton;
import javax.swing.JLabel;
import java.awt.GridBagLayout;
import java.awt.GridBagConstraints;
import java.util.Vector;

/**
 * @author Wolfgang Knauf
 * 
 * Frame-Fenster fr den Kern des KuchenZutatNM-Application-Client.
 * 
 * Enthlt die Main-Methode und zeigt zwei Listen mit Kuchen und Zutaten an.
 */
public class FrameKuchenZutatNM extends JFrame
{

  private javax.swing.JPanel jContentPane = null;

  private JScrollPane jScrollPaneKuchen = null;

  private JList jListKuchen = null;

  private JButton jButtonKuchenNeu = null;

  private JButton jButtonKuchenEdit = null;

  private JButton jButtonKuchenLoeschen = null;

  private JButton jButtonKuchenZutaten = null;

  private JScrollPane jScrollPaneZutat = null;

  private JList jListZutat = null;

  private JButton jButtonZutatNeu = null;

  private JButton jButtonZutatEdit = null;

  private JButton jButtonZutatLoeschen = null;

  private JButton jButtonZutatKuchen = null;

  private JLabel jLabelKuchen = null;

  private JLabel jLabelZutat = null;

  /**Main-Routine.
   * Zeigt den Frame an.
   * @param args
   */
  public static void main(String[] args)
  {
    FrameKuchenZutatNM frame = new FrameKuchenZutatNM();
    frame.pack();
    frame.show();
  }
  
  /**
   * This method initializes jScrollPane
   * 
   * @return javax.swing.JScrollPane
   */
  private JScrollPane getJScrollPaneKuchen()
  {
    if (jScrollPaneKuchen == null)
    {
      jScrollPaneKuchen = new JScrollPane();
      jScrollPaneKuchen.setName("jScrollPaneKuchen");
      jScrollPaneKuchen.setViewportView(getJListKuchen());
    }
    return jScrollPaneKuchen;
  }

  /**
   * This method initializes jList
   * 
   * @return javax.swing.JList
   */
  private JList getJListKuchen()
  {
    if (jListKuchen == null)
    {
      jListKuchen = new JList();
      jListKuchen.setName("jListKuchen");
      jListKuchen.setSelectionMode(javax.swing.ListSelectionModel.SINGLE_SELECTION);
    }
    return jListKuchen;
  }

  /**
   * This method initializes jButton
   * 
   * @return javax.swing.JButton
   */
  private JButton getJButtonKuchenNeu()
  {
    if (jButtonKuchenNeu == null)
    {
      jButtonKuchenNeu = new JButton();
      jButtonKuchenNeu.setName("jButtonKuchenNeu");
      jButtonKuchenNeu.setText("Neu");
      jButtonKuchenNeu.setToolTipText("Neuen Kuchen erstellen");
      jButtonKuchenNeu.addActionListener(new java.awt.event.ActionListener()
      {
        public void actionPerformed(java.awt.event.ActionEvent e)
        {
          //Aufruf der Methode fr das Neuanlegen eines Kuchens.
          kuchenNeu();
        }
      });
    }
    return jButtonKuchenNeu;
  }

  /**
   * This method initializes jButton
   * 
   * @return javax.swing.JButton
   */
  private JButton getJButtonKuchenEdit()
  {
    if (jButtonKuchenEdit == null)
    {
      jButtonKuchenEdit = new JButton();
      jButtonKuchenEdit.setName("jButtonKuchenEdit");
      jButtonKuchenEdit.setText("Bearbeiten");
      jButtonKuchenEdit.addActionListener(new java.awt.event.ActionListener()
      {
        public void actionPerformed(java.awt.event.ActionEvent e)
        {
          kuchenBearbeiten();
        }
      });
    }
    return jButtonKuchenEdit;
  }

  /**
   * This method initializes jButton
   * 
   * @return javax.swing.JButton
   */
  private JButton getJButtonKuchenLoeschen()
  {
    if (jButtonKuchenLoeschen == null)
    {
      jButtonKuchenLoeschen = new JButton();
      jButtonKuchenLoeschen.setText("Lschen");
      jButtonKuchenLoeschen.setName("jButtonKuchenLoeschen");
      jButtonKuchenLoeschen.addActionListener(new java.awt.event.ActionListener()
      {
        public void actionPerformed(java.awt.event.ActionEvent e)
        {
          kuchenLoeschen();
        }
      });
    }
    return jButtonKuchenLoeschen;
  }

  /**
   * This method initializes jButton
   * 
   * @return javax.swing.JButton
   */
  private JButton getJButtonKuchenZutaten()
  {
    if (jButtonKuchenZutaten == null)
    {
      jButtonKuchenZutaten = new JButton();
      jButtonKuchenZutaten.setText("Zutaten");
      jButtonKuchenZutaten.setName("jButtonKuchenZutaten");
      jButtonKuchenZutaten.addActionListener(new java.awt.event.ActionListener()
      {
        public void actionPerformed(java.awt.event.ActionEvent e)
        {
          kuchenZutaten();
        }
      });
    }
    return jButtonKuchenZutaten;
  }

  /**
   * This method initializes jScrollPane
   * 
   * @return javax.swing.JScrollPane
   */
  private JScrollPane getJScrollPaneZutat()
  {
    if (jScrollPaneZutat == null)
    {
      jScrollPaneZutat = new JScrollPane();
      jScrollPaneZutat.setName("jScrollPanelZutat");
      jScrollPaneZutat.setViewportView(getJListZutat());
    }
    return jScrollPaneZutat;
  }

  /**
   * This method initializes jList
   * 
   * @return javax.swing.JList
   */
  private JList getJListZutat()
  {
    if (jListZutat == null)
    {
      jListZutat = new JList();
      jListZutat.setName("jListZutat");
      jListZutat.setSelectionMode(javax.swing.ListSelectionModel.SINGLE_SELECTION);
    }
    return jListZutat;
  }

  /**
   * This method initializes jButton
   * 
   * @return javax.swing.JButton
   */
  private JButton getJButtonZutatNeu()
  {
    if (jButtonZutatNeu == null)
    {
      jButtonZutatNeu = new JButton();
      jButtonZutatNeu.setName("jButtonZutatNeu");
      jButtonZutatNeu.setText("Neu");
      jButtonZutatNeu.addActionListener(new java.awt.event.ActionListener()
      {
        public void actionPerformed(java.awt.event.ActionEvent e)
        {
          zutatNeu();
        }
      });
    }
    return jButtonZutatNeu;
  }

  /**
   * This method initializes jButton
   * 
   * @return javax.swing.JButton
   */
  private JButton getJButtonZutatEdit()
  {
    if (jButtonZutatEdit == null)
    {
      jButtonZutatEdit = new JButton();
      jButtonZutatEdit.setText("Bearbeiten");
      jButtonZutatEdit.setName("jButtonZutatEdit");
      jButtonZutatEdit.addActionListener(new java.awt.event.ActionListener()
      {
        public void actionPerformed(java.awt.event.ActionEvent e)
        {
          zutatBearbeiten();
        }
      });
    }
    return jButtonZutatEdit;
  }

  /**
   * This method initializes jButton
   * 
   * @return javax.swing.JButton
   */
  private JButton getJButtonZutatLoeschen()
  {
    if (jButtonZutatLoeschen == null)
    {
      jButtonZutatLoeschen = new JButton();
      jButtonZutatLoeschen.setName("jButtonZutatLoeschen");
      jButtonZutatLoeschen.setText("Lschen");
      jButtonZutatLoeschen.addActionListener(new java.awt.event.ActionListener()
      {
        public void actionPerformed(java.awt.event.ActionEvent e)
        {
          zutatLoeschen();
        }
      });
    }
    return jButtonZutatLoeschen;
  }

  /**
   * This method initializes jButton
   * 
   * @return javax.swing.JButton
   */
  private JButton getJButtonZutatKuchen()
  {
    if (jButtonZutatKuchen == null)
    {
      jButtonZutatKuchen = new JButton();
      jButtonZutatKuchen.setName("jButtonZutatKuchen");
      jButtonZutatKuchen.setText("Kuchen");
      jButtonZutatKuchen.addActionListener(new java.awt.event.ActionListener()
      {
        public void actionPerformed(java.awt.event.ActionEvent e)
        {
          zutatenKuchen();
        }
      });
    }
    return jButtonZutatKuchen;
  }

  /**
   * This is the default constructor
   */
  public FrameKuchenZutatNM()
  {
    super();
    initialize();
    
    //Ein paar Dummy-Daten:
    Vector vectorKuchen = new Vector();
    vectorKuchen.add ("Kuchen 1");
    vectorKuchen.add ("Kuchen 2");
    vectorKuchen.add ("Kuchen 3");
    vectorKuchen.add ("Kuchen 4");
    vectorKuchen.add ("Kuchen 5");
    vectorKuchen.add ("Kuchen 6");
    vectorKuchen.add ("Kuchen 7");
    vectorKuchen.add ("Kuchen 8");
    vectorKuchen.add ("Kuchen 9");
    vectorKuchen.add ("Kuchen 10");
    vectorKuchen.add ("Kuchen 11");
    vectorKuchen.add ("Kuchen 11");
    vectorKuchen.add ("Kuchen 12");
    vectorKuchen.add ("Kuchen 13");
    this.jListKuchen.setListData(vectorKuchen);
    
    
    Vector vectorZutat = new Vector();
    vectorZutat.add ("Zutat 1");
    vectorZutat.add ("Zutat 2");
    vectorZutat.add ("Zutat 3");
    vectorZutat.add ("Zutat 4");
    vectorZutat.add ("Zutat 5");
    vectorZutat.add ("Zutat 6");
    vectorZutat.add ("Zutat 7");
    vectorZutat.add ("Zutat 8");
    vectorZutat.add ("Zutat 9");
    vectorZutat.add ("Zutat 10");
    vectorZutat.add ("Zutat 11");
    vectorZutat.add ("Zutat 11");
    vectorZutat.add ("Zutat 12");
    vectorZutat.add ("Zutat 13");
    this.jListZutat.setListData(vectorZutat);
  }

  /**
   * This method initializes this
   * 
   * @return void
   */
  private void initialize()
  {
    this.setDefaultCloseOperation(javax.swing.JFrame.EXIT_ON_CLOSE);
    this.setName("jFrameKuchenZutat");
    this.setSize(456, 200);
    this.setContentPane(getJContentPane());
    this.setTitle("Kuchen und Zutaten");
  }

  /**
   * This method initializes jContentPane
   * 
   * @return javax.swing.JPanel
   */
  private javax.swing.JPanel getJContentPane()
  {
    if (jContentPane == null)
    {
      jLabelKuchen = new JLabel();
      jLabelZutat = new JLabel();
      GridBagConstraints gridBagConstraints12 = new GridBagConstraints();
      GridBagConstraints gridBagConstraints11 = new GridBagConstraints();
      GridBagConstraints gridBagConstraints10 = new GridBagConstraints();
      GridBagConstraints gridBagConstraints9 = new GridBagConstraints();
      GridBagConstraints gridBagConstraints8 = new GridBagConstraints();
      GridBagConstraints gridBagConstraints7 = new GridBagConstraints();
      GridBagConstraints gridBagConstraints6 = new GridBagConstraints();
      GridBagConstraints gridBagConstraints5 = new GridBagConstraints();
      GridBagConstraints gridBagConstraints4 = new GridBagConstraints();
      GridBagConstraints gridBagConstraints3 = new GridBagConstraints();
      GridBagConstraints gridBagConstraints2 = new GridBagConstraints();
      GridBagConstraints gridBagConstraints1 = new GridBagConstraints();
      jContentPane = new javax.swing.JPanel();
      jContentPane.setLayout(new GridBagLayout());
      jLabelKuchen.setText("Kuchen:");
      jLabelKuchen.setName("jLabelKuchen");
      jLabelKuchen.setFont(new java.awt.Font("Dialog", java.awt.Font.BOLD, 14));
      jLabelZutat.setText("Zutaten:");
      jLabelZutat.setName("jLabelZutat");
      jLabelZutat.setFont(new java.awt.Font("Dialog", java.awt.Font.BOLD, 14));
      gridBagConstraints1.gridx = 0;
      gridBagConstraints1.gridy = 1;
      gridBagConstraints1.gridheight = 4;
      gridBagConstraints1.weightx = 0.5D;
      gridBagConstraints1.weighty = 1.0;
      gridBagConstraints1.fill = java.awt.GridBagConstraints.BOTH;
      gridBagConstraints1.ipadx = 0;
      gridBagConstraints1.ipady = 0;
      gridBagConstraints1.insets = new java.awt.Insets(5, 5, 5, 5);
      gridBagConstraints2.gridx = 1;
      gridBagConstraints2.gridy = 1;
      gridBagConstraints2.ipadx = 0;
      gridBagConstraints2.ipady = 0;
      gridBagConstraints2.insets = new java.awt.Insets(5, 5, 5, 5);
      gridBagConstraints2.fill = java.awt.GridBagConstraints.HORIZONTAL;
      gridBagConstraints3.gridx = 1;
      gridBagConstraints3.gridy = 2;
      gridBagConstraints3.gridheight = 1;
      gridBagConstraints3.ipadx = 0;
      gridBagConstraints3.ipady = 0;
      gridBagConstraints3.insets = new java.awt.Insets(5, 5, 5, 5);
      gridBagConstraints3.fill = java.awt.GridBagConstraints.HORIZONTAL;
      gridBagConstraints4.gridx = 1;
      gridBagConstraints4.gridy = 3;
      gridBagConstraints4.gridheight = 1;
      gridBagConstraints4.ipadx = 0;
      gridBagConstraints4.ipady = 0;
      gridBagConstraints4.insets = new java.awt.Insets(5, 5, 5, 5);
      gridBagConstraints4.fill = java.awt.GridBagConstraints.HORIZONTAL;
      gridBagConstraints5.gridx = 1;
      gridBagConstraints5.gridy = 4;
      gridBagConstraints5.gridheight = 1;
      gridBagConstraints5.ipadx = 0;
      gridBagConstraints5.ipady = 0;
      gridBagConstraints5.insets = new java.awt.Insets(5, 5, 5, 5);
      gridBagConstraints5.fill = java.awt.GridBagConstraints.HORIZONTAL;
      gridBagConstraints6.gridx = 2;
      gridBagConstraints6.gridy = 1;
      gridBagConstraints6.gridheight = 4;
      gridBagConstraints6.weightx = 0.5D;
      gridBagConstraints6.weighty = 1.0;
      gridBagConstraints6.fill = java.awt.GridBagConstraints.BOTH;
      gridBagConstraints6.ipadx = 0;
      gridBagConstraints6.ipady = 0;
      gridBagConstraints6.insets = new java.awt.Insets(5, 5, 5, 5);
      gridBagConstraints7.gridx = 3;
      gridBagConstraints7.gridy = 1;
      gridBagConstraints7.gridheight = 1;
      gridBagConstraints7.ipadx = 0;
      gridBagConstraints7.ipady = 0;
      gridBagConstraints7.insets = new java.awt.Insets(5, 5, 5, 5);
      gridBagConstraints7.fill = java.awt.GridBagConstraints.HORIZONTAL;
      gridBagConstraints8.gridx = 3;
      gridBagConstraints8.gridy = 2;
      gridBagConstraints8.gridheight = 1;
      gridBagConstraints8.ipadx = 0;
      gridBagConstraints8.ipady = 0;
      gridBagConstraints8.insets = new java.awt.Insets(5, 5, 5, 5);
      gridBagConstraints8.fill = java.awt.GridBagConstraints.HORIZONTAL;
      gridBagConstraints9.gridx = 3;
      gridBagConstraints9.gridy = 3;
      gridBagConstraints9.gridheight = 1;
      gridBagConstraints9.ipadx = 0;
      gridBagConstraints9.ipady = 0;
      gridBagConstraints9.insets = new java.awt.Insets(5, 5, 5, 5);
      gridBagConstraints9.fill = java.awt.GridBagConstraints.HORIZONTAL;
      gridBagConstraints10.gridx = 3;
      gridBagConstraints10.gridy = 4;
      gridBagConstraints10.ipadx = 0;
      gridBagConstraints10.ipady = 0;
      gridBagConstraints10.insets = new java.awt.Insets(5, 5, 5, 5);
      gridBagConstraints10.anchor = java.awt.GridBagConstraints.NORTH;
      gridBagConstraints10.fill = java.awt.GridBagConstraints.HORIZONTAL;
      gridBagConstraints11.gridx = 0;
      gridBagConstraints11.gridy = 0;
      gridBagConstraints11.ipadx = 0;
      gridBagConstraints11.ipady = 0;
      gridBagConstraints11.insets = new java.awt.Insets(5, 5, 5, 5);
      gridBagConstraints11.anchor = java.awt.GridBagConstraints.WEST;
      gridBagConstraints12.gridx = 2;
      gridBagConstraints12.gridy = 0;
      gridBagConstraints12.ipadx = 0;
      gridBagConstraints12.ipady = 0;
      gridBagConstraints12.insets = new java.awt.Insets(5, 5, 5, 5);
      gridBagConstraints12.anchor = java.awt.GridBagConstraints.WEST;
      jContentPane.add(getJScrollPaneKuchen(), gridBagConstraints1);
      jContentPane.add(getJButtonKuchenNeu(), gridBagConstraints2);
      jContentPane.add(getJButtonKuchenEdit(), gridBagConstraints3);
      jContentPane.add(getJButtonKuchenLoeschen(), gridBagConstraints4);
      jContentPane.add(getJButtonKuchenZutaten(), gridBagConstraints5);
      jContentPane.add(getJScrollPaneZutat(), gridBagConstraints6);
      jContentPane.add(getJButtonZutatNeu(), gridBagConstraints7);
      jContentPane.add(getJButtonZutatEdit(), gridBagConstraints8);
      jContentPane.add(getJButtonZutatLoeschen(), gridBagConstraints9);
      jContentPane.add(getJButtonZutatKuchen(), gridBagConstraints10);
      jContentPane.add(jLabelKuchen, gridBagConstraints11);
      jContentPane.add(jLabelZutat, gridBagConstraints12);
    }
    return jContentPane;
  }

  /**
   * Klick auf "Neuen Kuchen anlegen".
   *  
   */
  private void kuchenNeu()
  {
    /** @todo "Neuen Kuchen anlegen" implementieren. */
    
    DialogKuchenBearbeiten dialog = new DialogKuchenBearbeiten(this);
    dialog.show();
  }
  
  /**
   * Klick auf "Kuchen bearbeiten".
   *  
   */
  private void kuchenBearbeiten()
  {
    /** @todo "Kuchen bearbeiten" implementieren. */
    
    DialogKuchenBearbeiten dialog = new DialogKuchenBearbeiten(this);
    dialog.show();
  }
  
  /**
   * Klick auf "Kuchen lschen".
   *  
   */
  private void kuchenLoeschen()
  {
    /** @todo "Kuchen lschen" implementieren. */
    
    JOptionPane.showMessageDialog(this, "Lschen implementieren");
  }
  
  /**
   * Klick auf "Kuchen-Zutaten bearbeiten".
   *  
   */
  private void kuchenZutaten()
  {
    /** @todo "Kuchen-Zutaten bearbeiten" implementieren. */
    DialogKuchenZutatenBearbeiten dialog = new DialogKuchenZutatenBearbeiten(this);
    dialog.show();
  }
  
  /**
   * Klick auf "Neue Zutat anlegen".
   *  
   */
  private void zutatNeu()
  {
    /** @todo "Neue Zutat anlegen" implementieren. */
    
    DialogZutatBearbeiten dialog = new DialogZutatBearbeiten(this);
    dialog.show();
  }
  
  /**
   * Klick auf "Zutat bearbeiten".
   *  
   */
  private void zutatBearbeiten()
  {
    /** @todo "Zutat bearbeiten" implementieren. */
    
    DialogZutatBearbeiten dialog = new DialogZutatBearbeiten(this);
    dialog.show();
  }
  
  /**
   * Klick auf "Zutat lschen".
   *  
   */
  private void zutatLoeschen()
  {
    /** @todo "Zutat lschen" implementieren. */
    
    JOptionPane.showMessageDialog(this, "Lschen implementieren");
  }
  
  /**
   * Klick auf "Kuchen der Zutat anzeigen".
   *  
   */
  private void zutatenKuchen()
  {
    /** @todo "Kuchen der Zutat anzeigen" implementieren. */
    DialogZutatKuchenAnzeigen dialog = new DialogZutatKuchenAnzeigen(this);
    dialog.show();
  }
} //  @jve:decl-index=0:visual-constraint="10,10"
